## sayonara 1.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project("Sayonara Player")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")

if( WITH_COTIRE )
	include(cotire)
	message("Compiling with Cotire")
	add_definitions(-D__STRICT_ANSI__)
else()
	message("Compiling without Cotire")
endif()

set(VAR_SAYONARA_VERSION "1.4.1-stable1")

set(SAYONARA_VERSION "${VAR_SAYONARA_VERSION}")
set(SAYONARA_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}")
set(SAYONARA_INSTALL_LIB_PATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/sayonara/")
set(SAYONARA_INSTALL_BIN_PATH "${CMAKE_INSTALL_PREFIX}/bin/")
set(SAYONARA_INSTALL_SHARE_PATH "${CMAKE_INSTALL_PREFIX}/share/sayonara/")

configure_file(Macros.h.in "${CMAKE_CURRENT_BINARY_DIR}/src/Utils/Macros.h" @ONLY)

message("Build Sayonara ${VAR_SAYONARA_VERSION}")
message("Will install to ${CMAKE_INSTALL_PREFIX}")

add_subdirectory(src)
add_subdirectory(resources)

string(TOLOWER "${CMAKE_BUILD_TYPE}" LOWER_CMAKE_BUILD_TYPE)
message("Lower cmake build type ${LOWER_CMAKE_BUILD_TYPE}")
if("${LOWER_CMAKE_BUILD_TYPE}" MATCHES "debug")
	SET(WITH_TESTS 1)
endif()

if( WITH_TESTS )
	message("Compiling with tests...")
	enable_testing()
	add_subdirectory(test)
else()
	message("Compiling without tests...")
	message(" In order to change that, use -DWITH_TESTS=1")
endif()

set(CMAKE_SKIP_RPATH:BOOL ON)
set(CMAKE_INSTALL_MANIFEST "install_manifest.txt")

=== src/CMakeLists.txt ===
project(sayonara)

include(FindPkgConfig)
include(compiler.cmake)

# Run Automoc/Autouic over autogenerated source files (e.g. from qrc files)
if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

if(WIN32)
	pkg_check_modules(GIO gio-windows-2.0 REQUIRED)
endif()

pkg_check_modules(TAGLIB taglib>=1.6 REQUIRED)
pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(GOBJECT gobject-2.0 REQUIRED)
pkg_check_modules(GSTREAMER gstreamer-1.0 REQUIRED)
pkg_check_modules(GSTREAMER_BASE gstreamer-base-1.0 REQUIRED)
pkg_check_modules(GSTREAMER_BASE_APP gstreamer-app-1.0 REQUIRED)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

if( NOT DEFINED CMAKE_BUILD_TYPE OR NOT CMAKE_BUILD_TYPE )
	message("Use standard build type \"Release\"")
	set(CMAKE_BUILD_TYPE "Release")
endif()

find_package(Qt5 COMPONENTS Core Widgets Sql Network DBus Xml REQUIRED)
find_package(Qt5LinguistTools REQUIRED)

set(CMAKE_AUTOMOC ON)
#set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Widgets_INCLUDE_DIRS})
include_directories(${Qt5Xml_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${GOBJECT_INCLUDE_DIRS})
include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${GSTREAMER_BASE_INCLUDE_DIRS})
include_directories(${TAGLIB_INCLUDE_DIRS})

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src)

add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${QT_DEFINITIONS})
add_definitions(-DLIB_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}/lib/sayonara")
if(WIN32)
	message("Windows: host Will compile without dbus and shutdown support")

else()
	message("No Windows: Will compile with dbus and shutdown support")
	add_definitions(-DWITH_DBUS)
	add_definitions(-DWITH_SHUTDOWN)
	set(WIN32 0)
endif()

link_directories(${GSTREAMER_LIBRARY_DIRS})

if(WIN32)
	link_directories(${GIO_LIBRARY_DIRS})
elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
	find_library(execinfo_LIB execinfo)
	if(NOT execinfo_LIB)
		message(FATAL_ERROR "FreeBSD requires execinfo library")
	endif()
	set(OS_LIBRARIES ${execinfo_LIB})
endif()


add_subdirectory(Application)
add_subdirectory(Gui)
add_subdirectory(Utils)
add_subdirectory(Database)
add_subdirectory(Interfaces)
add_subdirectory(Components)
add_subdirectory(Languages)
add_subdirectory(3rdParty)

set(SOURCES
	Main.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES} ${QM_FILES})

#file(GLOB_RECURSE HeaderFiles "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
#add_custom_target(headers SOURCES ${HeaderFiles})

if(WIN32)
	set(OS_LIBRARIES
		api-ms-win-core-winrt-l1-1-0
		api-ms-win-core-winrt-string-l1-1-0
		${GIO_LIBRARIES}
	)
endif()


target_link_libraries(${PROJECT_NAME}
	say_application
	say_gui_resources
	say_lang
	${OS_LIBRARIES}
)


if(WIN32)
	install(TARGETS ${PROJECT_NAME} DESTINATION .)
else()
	install(TARGETS ${PROJECT_NAME} DESTINATION bin)
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(say_tests)
include(${CMAKE_CURRENT_SOURCE_DIR}/../src/compiler.cmake)

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

find_package(Qt5 COMPONENTS Core Widgets Sql Network DBus Network Xml Test REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(RESOURCES
	resources/Test.qrc
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Widgets_INCLUDE_DIRS})
include_directories(${Qt5Xml_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../src")

add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${QT_DEFINITIONS})

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src)

include_directories(${CMAKE_SOURCE_DIR}/test)
include_directories(${CMAKE_BINARY_DIR}/test)

include("new_test.cmake")
QT5_ADD_RESOURCES(RESOURCES_RCC
		${RESOURCES}
)

NEW_TEST(Database/PodcastTest.cpp)
NEW_TEST(Database/AlbumTest.cpp)

NEW_TEST(Helper/CryptTest.cpp)
NEW_TEST(Helper/FileHelperTest.cpp)
NEW_TEST(Helper/MetaDataListTest.cpp)
NEW_TEST(Helper/LanguageKeyTest.cpp)
NEW_TEST(Helper/MetaDataTest.cpp)
NEW_TEST(Helper/SettingsTest.cpp)
#NEW_TEST(Shortcuts/ShortcutIdentifierTest.cpp)
NEW_TEST(StreamRecorder/StreamRecorderUtilsTest.cpp)
NEW_TEST(StreamRecorder/StreamRecorderTest.cpp)
NEW_TEST(Tagging/LyricsTest.cpp ${RESOURCES_RCC} Tagging/AbstractTaggingTest.cpp)
NEW_TEST(Tagging/AlbumArtistTest.cpp ${RESOURCES_RCC} Tagging/AbstractTaggingTest.cpp)
NEW_TEST(Tagging/DiscnumberTest.cpp ${RESOURCES_RCC} Tagging/AbstractTaggingTest.cpp)
NEW_TEST(Tagging/RatingTest.cpp ${RESOURCES_RCC} Tagging/AbstractTaggingTest.cpp)

#NEW_TEST(StreamSearchTest.cpp)

=== src/3rdParty/CMakeLists.txt ===
ADD_SUBDIRECTORY(Soundcloud)
ADD_SUBDIRECTORY(SomaFM)

=== src/Application/CMakeLists.txt ===
project(say_application)

include_directories(
	${CMAKE_CURRENT_BINARY_DIR},
	${CMAKE_CURRENT_SOURCE_DIR}
)

file(GLOB_RECURSE SOURCES . *.cpp)

set(APPLICATION_LIBRARIES
	say_gui_library
	say_gui_directory_widget

	say_gui_player
	say_gui_preferences
	say_gui_plugins

	say_interfaces_libraryinterface
	say_comp_remote_control
	say_comp_session
)

if(NOT WIN32 OR NOT DEFINED WIN32)
	set(APPLICATION_LIBRARIES
	${APPLICATION_LIBRARIES}
	say_comp_dbus
	)
else()
	set(APPLICATION_LIBRARIES
		${APPLICATION_LIBRARIES}
		sayonara_somafm
		sayonara_soundcloud
	)
endif()

add_library(${PROJECT_NAME} STATIC ${SOURCES})
target_link_libraries(${PROJECT_NAME}
	${APPLICATION_LIBRARIES}
)

add_library(sayonara_test SHARED ${SOURCES})
target_link_libraries(sayonara_test
	${APPLICATION_LIBRARIES}
	say_gui_resources
)

=== src/Components/CMakeLists.txt ===
project(say_comp)

add_subdirectory(Bookmarks)
add_subdirectory(Broadcasting)
add_subdirectory(Converter)
add_subdirectory(Covers)

if( NOT WIN32 OR NOT DEFINED WIN32 )
	add_subdirectory(DBus)
	add_subdirectory(Shutdown)
endif()

add_subdirectory(Directories)
add_subdirectory(Engine)
add_subdirectory(Library)
add_subdirectory(Lyrics)
add_subdirectory(MetaDataInfo)
add_subdirectory(Playlist)
add_subdirectory(PlaylistChooser)
add_subdirectory(PlayManager)
add_subdirectory(Preferences)
add_subdirectory(RemoteControl)
add_subdirectory(Session)
add_subdirectory(Streaming)
add_subdirectory(Tagging)

=== src/Database/CMakeLists.txt ===
project(say_db)

file(GLOB_RECURSE SOURCES . *.cpp)

add_library(${PROJECT_NAME} STATIC ${SOURCES} )
target_link_libraries(${PROJECT_NAME}
	Qt5::Sql
	say_utils
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/Gui/CMakeLists.txt ===
project(say_gui)

set(CMAKE_AUTOUIC ON)

add_subdirectory(Covers)
add_subdirectory(Directories)
add_subdirectory(InfoDialog)
add_subdirectory(Library)
add_subdirectory(Player)
add_subdirectory(Playlist)
add_subdirectory(Plugins)
add_subdirectory(Preferences)
add_subdirectory(Resources)
add_subdirectory(ShutdownDialog)
add_subdirectory(TagEdit)
add_subdirectory(Utils)
add_subdirectory(ImportDialog)

=== src/Utils/CMakeLists.txt ===
project(say_utils)

include(CheckIncludeFileCXX)
check_include_file_cxx("cxxabi.h" HAVE_CXX_ABI)
if(${HAVE_CXX_ABI})
	add_definitions("-DHAVE_CXX_ABI")
	message("Compile with demangle")
else()
	message("Demangle not found")
endif()

pkg_check_modules(ZLIB REQUIRED zlib)
include_directories(${ZLIB_INCLUDE_DIRS})

file(GLOB_RECURSE SOURCES . *.cpp)

add_library(${PROJECT_NAME} STATIC ${SOURCES})
target_link_libraries(${PROJECT_NAME}
	Qt5::Core
	Qt5::Network
	Qt5::Xml
	Qt5::DBus
	Qt5::Gui
	tag
	${ZLIB_LIBRARIES}
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/3rdParty/SomaFM/CMakeLists.txt ===
project( sayonara_somafm )

file(GLOB_RECURSE SOURCES . *.cpp)
set(CMAKE_AUTOUIC ON)

qt5_add_resources(RESOURCES
    ui/SomaFMIcons.qrc
)

if( WIN32 )
    add_library(${PROJECT_NAME} STATIC ${SOURCES} ${RESOURCES})
else()
    add_library(${PROJECT_NAME} SHARED ${SOURCES} ${RESOURCES})
endif()

target_link_libraries(${PROJECT_NAME}
    say_gui_utils
    say_comp_playlist
    say_interfaces_library_container
)

if( WITH_COTIRE )
    cotire(${PROJECT_NAME})
endif()

if(NOT WIN32 OR NOT DEFINED WIN32)
    install(TARGETS ${PROJECT_NAME} DESTINATION lib${LIB_SUFFIX}/sayonara)
endif()

=== src/3rdParty/Soundcloud/CMakeLists.txt ===
project(sayonara_soundcloud)

file(GLOB_RECURSE SOURCES . *.cpp)

set(CMAKE_AUTOUIC ON)
set(RESOURCES
	SoundcloudIcons.qrc
)

qt5_add_resources(RESOURCES_RCC ${RESOURCES})

if(WIN32)
	add_library(${PROJECT_NAME} STATIC ${SOURCES} ${RESOURCES_RCC})
	set(SOUNDCLOUD_INSTALL_PATH
		"share"
	)
else()
	add_library(${PROJECT_NAME} SHARED ${SOURCES} ${RESOURCES_RCC})
	set(SOUNDCLOUD_INSTALL_PATH
		"share/sayonara"
	)

endif()

target_link_libraries(${PROJECT_NAME}
	say_db
	say_gui_utils
	say_gui_library
	say_interfaces_library_container
)

if( WITH_COTIRE )
    cotire(${PROJECT_NAME})
endif()

if(NOT WIN32 OR NOT DEFINED WIN32)
	install(TARGETS ${PROJECT_NAME} DESTINATION lib${LIB_SUFFIX}/sayonara)
endif()

install(FILES "soundcloud.db" DESTINATION ${SOUNDCLOUD_INSTALL_PATH})

=== src/Components/Converter/CMakeLists.txt ===
project(say_comp_converter)

file(GLOB_RECURSE SOURCES . *.cpp)

add_library(${PROJECT_NAME} STATIC ${SOURCES})
target_link_libraries(${PROJECT_NAME}
	say_comp_playlist
)

=== debian/changelog ===
sayonara (1.4.1-0.1~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.
  * Disable dbgsym packages.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 02 Aug 2019 13:38:13 -0700

sayonara (1.4.1-0ppa1-bionic1) bionic; urgency=low

  * Language: Added ability to check for updates
  * Language: Fixed some runtime tranlation issues
  * Library: Genre View issue fixed
  * Library: Artist field in Cover view fixed
  * Streams: Remove jumping of time label

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 26 May 2019 22:04:26 +0200

sayonara (1.4.0-0ppa1-bionic1) bionic; urgency=low

  * Covers: Faster cover view
  * Covers: File searcher reactivated 
  * Covers: Save options
  * Importer: Zip support
  * Library: Show tracks w/o genre
  * Library: Column resize saved
  * Player: MPRIS revisited
  * Player: KDE Plasma fix 
  * Streams: Radio station search support
  * Raspberry: 32/64 bit issues fixed

 -- Lucio Carreras <luciocarreras@gmail.com>  Sat, 25 May 2019 12:26:27 +0200

sayonara (1.3.0-0ppa2-bionic1) bionic; urgency=low

  * Language update 

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 28 Apr 2019 15:17:24 +0200

sayonara (1.3.0-0ppa1-bionic1) bionic; urgency=low

  * rar support
  * Cover View: Significantly reduces memory consumption
  * Tags: Cover support for xiph headers
  * Tags: Comment section
  * Info Dialog: Layout update
  * Tag Editor: Segfault fixed
  * Audio Converter revisited
  * Audio Converter only for flac and wav files now 
  * Audio Converter use external tools from lame and vorbistools
  * Track View: Column widths
  * LastFM Login fixed
  * Info dialog: Bugfixes

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 28 Apr 2019 14:28:50 +0200

sayonara (1.1.1-0ppa4-bionic1) bionic; urgency=low

  * Genre selection: artist view fixed 

 -- Lucio Carreras <luciocarreras@gmail.com>  Wed, 05 Sep 2018 22:17:01 +0200

sayonara (1.1.1-0ppa3-bionic1) bionic; urgency=low

  * Tray icon bug fixed 

 -- Lucio Carreras <luciocarreras@gmail.com>  Thu, 30 Aug 2018 14:45:25 +0200

sayonara (1.1.1-0ppa2-bionic1) bionic; urgency=low

  * Czech and French language updates
  * Notify new version bugfix
  * Multi instance bugfix

 -- Lucio Carreras <luciocarreras@gmail.com>  Tue, 28 Aug 2018 07:35:25 +0200

sayonara (1.1.1-0ppa1-bionic1) bionic; urgency=low

  * User Interface: Show a big cover and Rating
  * Cover View: Show artists
  * Cover View: Sort by artists
  * Cover View: Toolbar enhancements
  * Cover View: Caching
  * Covers: Enhanced cover search
  * Covers: Use more covers from audio files
  * Library: Deleting/Adding new libraries bugfixes
  * Library: Search mode fixes
  * Crossfader/Gapless playback accessibility
  * Shortcut for switching to album cover view
  * Shortcut for switching show album artists
  * Shortcut for showing/hiding the library
  * Playlist: Show Rating
  * Playlist: Show little covers
  * Playlist: Number, Title, Artist and Album customizable
  * Playlist Chooser bugfixes
  * Playlist View bugfixes
  * Tag Editor: Save/Load comments
  * Crossfader/Gapless Playback: Easier access through the playlist window
  * Stream Recorder: Automatic recording
  * Stream Recorder: More sophisticated path templates
  * Stream Recorder: Path templates fixed
  * Database: Encrypted passwords
  * Lyrics: Save/Load from Audio file
  * Languages: Use transifex.com for translations
  * Languages: Japanese and Arabic added
  * And a lot of bug fixes

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 26 Aug 2018 18:47:34 +0200

sayonara (1.1.0-0ppa1-bionic1) bionic; urgency=low

  * Cover Cache in DB
  * Ui Improvements

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 26 Aug 2018 18:10:17 +0200

sayonara (1.0.0-0ppa6-bionic1) bionic; urgency=low

  * Stream recorder date fixes
  * Unity menubar workaround
  * Playlist format string (nr tag) fixed
  * Broadcasting progress (maybe not fixed entirely)
  * French language update
  * DBus fixed

 -- Lucio Carreras <luciocarreras@gmail.com>  Mon, 15 Jan 2018 01:43:16 +0100

sayonara (1.0.0-0ppa5-bionic1) bionic; urgency=low

  * Switch between Alsa and Pulseaudio
  * Unity menu fixes
  * Shortcuts for minimize and quit

 -- Lucio Carreras <luciocarreras@gmail.com>  Fri, 12 Jan 2018 22:31:06 +0100

sayonara (1.0.0-0ppa4-bionic1) bionic; urgency=low

  * Turkish language support
  * Ape support

 -- Lucio Carreras <luciocarreras@gmail.com>  Sat, 06 Jan 2018 12:36:15 +0100

sayonara (1.0.0-0ppa3-bionic1) bionic; urgency=low

  * Czech, russian and ukrainian language updates
  * compilation fixes

 -- Lucio Carreras <luciocarreras@gmail.com>  Fri, 05 Jan 2018 20:20:37 +0100

sayonara (1.0.0-0ppa2-bionic1) bionic; urgency=low

  * library view fixes
  * cover view crash removed

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 31 Dec 2017 14:04:07 +0100

sayonara (1.0.0-0ppa1-bionic1) bionic; urgency=low

  * Covers: Choose between Google, Discogs and Last.fm covers
  * Cover view: Reload covers, zoom and sorting
  * Directories: Multiple library support
  * Directories: Move/Copy/Rename operations
  * Directories: Show Song info
  * Library: Multiple library support
  * Library: Removed date filter support
  * Library: "Clear selection" button
  * Library: Bugfix: Search modes immediatly updated
  * Look & Feel: Choose system icons
  * Look & Feel: Fast preference access
  * Lyrics: Lyric server updates
  * MTP: Removed MTP device support
  * Playback: Crossfader revisited
  * Playlists: Moved load/save to playlist tabs instead of plugin
  * Proxy: Added proxy support
  * Stream recorder: Custom paths
  * Streams/Podcast: Added preferences

 -- Lucio Carreras <luciocarreras@gmail.com>  Sat, 30 Dec 2017 12:09:50 +0100

sayonara (0.9.3-0ppa5-bionic1) bionic; urgency=low

  * Ubuntu bionic package

 -- Lucio Carreras <luciocarreras@gmail.com>  Sun, 05 Nov 2017 13:37:48 +0100

sayonara (0.9.3-0ppa4-bionic1) bionic; urgency=low

  * Language Update
  * Faster library cover view



=== debian/control ===
Source: sayonara
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Lucio Carreras <luciocarreras@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               libgstreamer-plugins-bad1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libtag1-dev (>= 1.11),
               pkg-config,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://sayonara-player.com

Package: sayonara
Architecture: any
Depends: gstreamer1.0-plugins-ugly,
         gstreamer1.0-plugins-bad,
         gstreamer1.0-plugins-good,
         libqt5sql5-sqlite,
         ${misc:Depends},
         ${shlibs:Depends}
Description: small and lightweight music player.
 Sayonara is a lightweight and fast music library manager and player.
 It has a lot of features like:
 - Many supported music and playlist formats
 - Media library with search function
 - Directory view
 - External device support
 - Genre organization
 - Playlist view organized by tabs
 - (Dynamic) playback
 - Equalizer
 - Metadata editor (including tags from path)
 - Lyrics
 - Shutdown function
 - MP3 Converter
 - Customizable spectrum analyzer and level meter
 - Last.FM radio and scrobbling
 - Soundcloud support
 - Internet streams
 - Stream recorder
 - Podcasts
 - Radio Broadcasting
 - Multimedia key support
 - Desktop integration (DBus Mpris2 compatible)
 - 2 skins

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## sayonara 1.6.0~beta6+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project("Sayonara Player")

option(WITH_DOC "Building with doxygen support" OFF)
option(WITH_TESTS "Building with tests" OFF)
option(WITH_COTIRE "Building with cotire PCH and compile time optimizations" OFF)
option(WITH_SYSTEM_TAGLIB "Use the taglib provided by the destribution, which contains critical bugs in 1.11" OFF)
option(LINK_GSTREAMER_PLUGINS "Link the most common GStreamer plugins into the binary. Used for the creation of AppImage files")
option(WITH_CCACHE "Use CCache if available" OFF)

get_property(HAS_64_SUFFIX GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if(HAS_64_SUFFIX)
	set(LIB_SUFFIX "64")
else()
	set(LIB_SUFFIX "")
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")

set(SAYONARA_VERSION "1.6.0-beta6")
set(SAYONARA_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}")
set(SAYONARA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
set(SAYONARA_INSTALL_BIN_PATH "${CMAKE_INSTALL_PREFIX}/bin/")
set(SAYONARA_INSTALL_LIB_PATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/sayonara/")
set(SAYONARA_INSTALL_SHARE_PATH "${CMAKE_INSTALL_PREFIX}/share/sayonara/")

message("Build Sayonara ${VAR_SAYONARA_VERSION}")
message("Will install to ${CMAKE_INSTALL_PREFIX}")

# used for cmakedefine in Macros.h.in
set(SAYONARA_WITH_TESTS ${WITH_TESTS})
string(TOLOWER "${CMAKE_BUILD_TYPE}" LOWER_CMAKE_BUILD_TYPE)
if("${LOWER_CMAKE_BUILD_TYPE}" MATCHES "debug")
	set(SAYONARA_WITH_TESTS 1)
endif()

add_subdirectory(dist)
add_subdirectory(src)
add_subdirectory(resources)

message("Lower cmake build type ${LOWER_CMAKE_BUILD_TYPE}")

if(SAYONARA_WITH_TESTS)
	message("Compiling with tests...")
	enable_testing()
	add_subdirectory(test)
else()
	message("Compiling without tests...")
	message(" In order to change that, use -DWITH_TESTS=1")
endif()

set(CMAKE_INSTALL_MANIFEST "install_manifest.txt")

# doxygen
message ("Looking for doxygen")
find_package(Doxygen)

if (WITH_DOC)
	if (DOXYGEN_FOUND)
		message ("Doxygen found")
		set(DOXYFILE_IN "${CMAKE_SOURCE_DIR}/docs/doxygen.in")
		set(DOXYFILE_OUT "${CMAKE_BINARY_DIR}/docs/doxygen.cfg")
		set(DOXYFILE_SRC_DIR "${CMAKE_SOURCE_DIR}")
		set(DOXYFILE_OUTPUT_DIR "${CMAKE_BINARY_DIR}/docs")

		include(FindPerl OPTIONAL)
		set(DOXYFILE_PERL_EXECUTABLE "${PERL_EXECUTABLE}")

		configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

		add_custom_target(doc
			COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src"
			COMMENT "Generating documentation..."
			VERBATIM
		)

	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs/html DESTINATION share/doc/sayonara/doxygen)

	endif (DOXYGEN_FOUND)
endif (WITH_DOC)

=== dist/CMakeLists.txt ===
execute_process(COMMAND env LC_TIME="en_US.utf8" date "+%a %b %d %Y" OUTPUT_VARIABLE SAYONARA_DATE_TODAY)
string(REGEX REPLACE "\n$" "" SAYONARA_DATE_TODAY "${SAYONARA_DATE_TODAY}")
string(REGEX MATCH "[0-9]+(\.[0-9])+" SAYONARA_VERSION_BASE "${SAYONARA_VERSION}")
string(REGEX MATCH "[a-z]+[0-9]+" SAYONARA_VERSION_RELEASE ${SAYONARA_VERSION})

configure_file(sayonara.spec.in ${CMAKE_CURRENT_BINARY_DIR}/sayonara.spec @ONLY)

=== resources/CMakeLists.txt ===
project(say_resources)

# create sayonara menu file
# menu file not needed anymore since .desktop file exists
# configure_file(sayonara.menu.in
#	${CMAKE_CURRENT_BINARY_DIR}/sayonara
#	@ONLY
# )

configure_file(version.in ${CMAKE_BINARY_DIR}/version @ONLY)

# manpage
find_program(GZIP_BINARY
	NAMES gzip	
)

if(NOT GZIP_BINARY)
    message("gzip not found. No manpage will be created")
else()
    ## create date for manpage
    execute_process(COMMAND env LC_TIME="en_US.utf8" date "+%d %B %Y" OUTPUT_VARIABLE SAYONARA_MANPAGE_DATE)
    string(REGEX REPLACE "\n$" "" SAYONARA_MANPAGE_DATE "${SAYONARA_MANPAGE_DATE}")
    
    ## create manpage
    configure_file(sayonara.1.man.in 
    	${CMAKE_CURRENT_BINARY_DIR}/sayonara.1 
    	@ONLY
    )

    ## create zipped manpage
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara.1)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara.1.gz" DESTINATION share/man/man1)
endif()

install(FILES "sayonara.desktop" DESTINATION share/applications)
install(FILES "sayonara.appdata.xml" DESTINATION share/appdata)
install(DIRECTORY "logos/" DESTINATION share/icons/hicolor)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(sayonara)

include(FindPkgConfig)
include(CheckIncludeFileCXX)
include(CMake/Compiler.cmake)
if(LINK_GSTREAMER_PLUGINS)
	include(CMake/GStreamer.cmake)
endif()

# absolute linker paths are no longer supoorted in -l parameter
# use -L for path and -l for library itself
if(POLICY CMP0003)
	cmake_policy(SET CMP0003 NEW)
endif()

# no more escaping of preprocessor definitions
if(POLICY CMP0005)
	cmake_policy(SET CMP0005 NEW)
endif()

# Run Automoc/Autouic over autogenerated source files (e.g. from qrc files)
if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

if(WITH_COTIRE)
	include(CMake/Cotire.cmake)
	message("Compiling with Cotire")
	add_definitions(-D__STRICT_ANSI__)
else()
	message("Compiling without Cotire")
endif()

if(WIN32)
	pkg_check_modules(GIO gio-windows-2.0 REQUIRED)
endif()


set(TAGLIB_FOUND 0)

if(WITH_SYSTEM_TAGLIB)
	message("Looking for system taglib")
	# overwrites TAGLIB_FOUND, TAGLIB_LIBRARY_DIRS, TAGLIB_LIBRARIES
	pkg_check_modules(TAGLIB taglib>=1.10 REQUIRED)

	# Some distributions do not clean the taglib include path
	# or the pkg-config .pc file for taglib after uninstalling
	find_path(TAGLIB_INCLUDE_FOUND "audioproperties.h" PATHS ${TAGLIB_INCLUDE_DIRS})
	if(NOT TAGLIB_INCLUDE_FOUND)
		message(FATAL_ERROR "Taglib does not seem to be fully installed" )
	endif()
endif()

if(NOT TAGLIB_FOUND)
	set(WITH_SYSTEM_TAGLIB 0)

	set(TAGLIB_INCLUDE_DIRS
		${CMAKE_SOURCE_DIR}/src/3rdParty
		${CMAKE_CURRENT_BINARY_DIR}/3rdParty
		${CMAKE_CURRENT_BINARY_DIR}/3rdParty/taglib
	)

	set(TAGLIB_LIBARARY_DIRS
		${CMAKE_CURRENT_BINARY_DIR}/3rdParty/taglib
	)

	set(TAGLIB_LIBRARY_DIRS ${CMAKE_CURRENT_BINARY_DIR}/3rdParty/taglib/taglib)
	set(TAGLIB_LIBRARIES tag)
	
	# Macros.h.in
	set(SAYONARA_INTERNAL_TAGLIB 1)
else()
	# Macros.h.in
	set(SAYONARA_SYSTEM_TAGLIB 1)
endif()

pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(GOBJECT gobject-2.0 REQUIRED)
pkg_check_modules(GSTREAMER gstreamer-1.0 REQUIRED)
pkg_check_modules(GSTREAMER_BASE gstreamer-base-1.0 REQUIRED)
pkg_check_modules(GSTREAMER_BASE_APP gstreamer-app-1.0 REQUIRED)
pkg_check_modules(ZLIB REQUIRED zlib REQUIRED)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

if( NOT DEFINED CMAKE_BUILD_TYPE OR NOT CMAKE_BUILD_TYPE )
	message("Use standard build type \"Release\"")
	set(CMAKE_BUILD_TYPE "Release")
endif()

# in order to choose another qt installation set CMAKE_PREFIX_PATH
find_package(Qt5 5.8 COMPONENTS Core Widgets Sql Network DBus Xml Svg REQUIRED)
find_package(Qt5LinguistTools REQUIRED)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Widgets_INCLUDE_DIRS})
include_directories(${Qt5Xml_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Svg_INCLUDE_DIRS})
include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${GOBJECT_INCLUDE_DIRS})
include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${GSTREAMER_BASE_INCLUDE_DIRS})
include_directories(${GSTREAMER_BASE_APP_INCLUDE_DIRS})
include_directories(${TAGLIB_INCLUDE_DIRS})
include_directories(${ZLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${QT_DEFINITIONS})

link_directories(${TAGLIB_LIBRARY_DIRS})
link_directories(${GLIB_LIBRARY_DIRS})
link_directories(${GSTREAMER_LIBRARY_DIRS})

# DBus and Shutdown
if(WIN32)
	message("Windows: host Will compile without dbus and shutdown support")
else()
	message("No Windows: Will compile with dbus and shutdown support")
	# Macros.h.in
	set(SAYONARA_WITH_DBUS 1)
	set(SAYONARA_WITH_SHUTDOWN 1)
	set(WIN32 0)
endif()

# check execinfo for FreeBSD
if(WIN32)
	link_directories(${GIO_LIBRARY_DIRS})
elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
	find_library(execinfo_LIB execinfo)
	if(NOT execinfo_LIB)
		message(FATAL_ERROR "FreeBSD requires execinfo library")
	endif()
	set(OS_LIBRARIES ${execinfo_LIB})
endif()


# Check demangle
check_include_file_cxx("cxxabi.h" HAVE_CXX_ABI)
if(${HAVE_CXX_ABI})
	# Macros.h.in
	set(SAYONARA_HAS_CXX_ABI 1)
	message("Compile with demangle")
else()
	message("Demangle not found")
endif()

configure_file(Macros.h.in "${CMAKE_CURRENT_BINARY_DIR}/Utils/Macros.h" @ONLY)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC OFF)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(3rdParty)
add_subdirectory(Application)
add_subdirectory(Components)
add_subdirectory(Database)
add_subdirectory(DBus)
add_subdirectory(Interfaces)
add_subdirectory(Gui)
add_subdirectory(Languages)
add_subdirectory(Utils)

qt5_add_resources(DATABASE_RCC
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Database.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Resources.qrc
)

add_executable(${PROJECT_NAME} Main.cpp ${QM_FILES} ${DATABASE_RCC})

if(WIN32)
	set(OS_LIBRARIES
		api-ms-win-core-winrt-l1-1-0
		api-ms-win-core-winrt-string-l1-1-0
		${GIO_LIBRARIES}
	)
endif()

target_link_libraries(${PROJECT_NAME}
	sayonara_application
	sayonara_languages

	${OS_LIBRARIES}
)

add_executable("create_db" CreateDB.cpp ${DATABASE_RCC})
target_link_libraries("create_db"
	sayonara_utils
	sayonara_database
	Qt5::Widgets
)

if(WIN32)
	install(TARGETS ${PROJECT_NAME} DESTINATION .)
else()
	install(TARGETS ${PROJECT_NAME} DESTINATION bin)
endif()

if(GSTREAMER_PLUGIN_LIBRARIES)
	message("Will install gstreamer plugins")
	install(FILES ${GSTREAMER_PLUGIN_LIBRARIES} DESTINATION lib/gstreamer-1.0)
	install(FILES ${GSTREAMER_PLUGIN_SCANNER} DESTINATION lib/gstreamer1.0/gstreamer-1.0)
endif()

=== test/CMakeLists.txt ===
project(say_tests)
include("NewTest.cmake")
include(${CMAKE_SOURCE_DIR}/src/CMake/Compiler.cmake)

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

find_package(Qt5 COMPONENTS Core Gui Sql Network Xml Test REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

file(COPY ${CMAKE_SOURCE_DIR}/resources/player.db
	DESTINATION	${CMAKE_CURRENT_BINARY_DIR}
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Gui_INCLUDE_DIRS})
include_directories(${Qt5Xml_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src)

add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${QT_DEFINITIONS})

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src/3rdParty)
include_directories(${CMAKE_BINARY_DIR}/src/3rdParty/taglib)

include_directories(${CMAKE_SOURCE_DIR}/test)
include_directories(${CMAKE_BINARY_DIR}/test)

set(RESOURCES
	resources/Test.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Database.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Resources.qrc
)

qt5_add_resources(RESOURCES_RCC
	${RESOURCES}
)

# With resources
new_test(Covers/CoverLocationTest.cpp)

new_test(Database/PodcastTest.cpp)
new_test(Database/AlbumTest.cpp)
new_test(Database/LibraryDatabaseTest.cpp)

new_test(Library/ImportCacheTest.cpp)

new_test(Playlist/PlaylistTest.cpp Playlist/PlaylistTestUtils.cpp)
new_test(Playlist/PlaylistTrackModifyTest.cpp Playlist/PlaylistTestUtils.cpp)

new_test(StreamRecorder/StreamRecorderTest.cpp)
new_test(StreamRecorder/StreamRecorderUtilsTest.cpp)

new_test(Tagging/AlbumArtistTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/DiscnumberTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/EditorTest.cpp)
new_test(Tagging/LyricsTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/RatingTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/TagFromPathTest.cpp)

new_test(Util/CryptTest.cpp)
new_test(Util/FileHelperTest.cpp)
new_test(Util/LanguageKeyTest.cpp)
new_test(Util/LanguageUtilTest.cpp)
new_test(Util/MetaDataTest.cpp)
new_test(Util/MetaDataListTest.cpp)
new_test(Util/SettingsTest.cpp)
new_test(Util/SetTest.cpp)
new_test(Util/CissearchTest.cpp)

=== src/Components/CMakeLists.txt ===
project(sayonara_components)

set(CMAKE_AUTOUIC OFF)

set(COMPONENTS
	Bookmarks
	Broadcasting
	Converter
	Covers
	Directories
	Engine
	Library
	LibraryManagement
	Lyrics
	MetaDataInfo
	Playlist
	PlaylistChooser
	PlayManager
	Preferences
	RemoteControl
	Session
	Shutdown
	Streaming
	Tagging
)

foreach(COMPONENT ${COMPONENTS})
	file(GLOB_RECURSE SOURCES ${COMPONENT} *.cpp)
	file(GLOB_RECURSE HEADERS ${COMPONENT} *.h)
endforeach()

qt5_add_resources(COMPONENT_RESOURCES_RCC
	${CMAKE_CURRENT_SOURCE_DIR}/Broadcasting/Broadcasting.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/Lyrics/Lyrics.qrc
)

add_library(${PROJECT_NAME} STATIC ${HEADERS} ${SOURCES} ${COMPONENT_RESOURCES_RCC})

target_link_libraries(${PROJECT_NAME}
	sayonara_database
	sayonara_interfaces

	${GSTREAMER_LIBRARIES}
	${GSTREAMER_BASE_LIBRARIES}
	${GSTREAMER_BASE_APP_LIBRARIES}

	Qt5::Svg
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/DBus/CMakeLists.txt ===
project(sayonara_dbus)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
set(CMAKE_AUTOMOC OFF)

set(DBUS_SOURCES
	DBusAdaptor.cpp
	DBusHandler.cpp
	DBusMPRIS.cpp
	DBusMediaKeysInterface.cpp
	DBusMediaKeysInterfaceGnome.cpp
	DBusMediaKeysInterfaceMate.cpp
	DBusNotifications.cpp
)

set(DBUS_HEADERS
	DBusAdaptor.h
	DBusHandler.h
	DBusMediaKeysInterfaceGnome.h
	DBusMediaKeysInterface.h
	DBusMediaKeysInterfaceMate.h
	DBusMPRIS.h
	DBusNotifications.h
)

qt5_wrap_cpp(DBUS_SOURCES
	${DBUS_HEADERS}
)

qt5_add_dbus_adaptor(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.mpris.MediaPlayer2.xml
	${CMAKE_SOURCE_DIR}/src/DBus/DBusMPRIS.h
	DBusMPRIS::MediaPlayer2
	org_mpris_media_player2_adaptor
	OrgMprisMediaPlayer2Adaptor
)

qt5_add_dbus_adaptor(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.mpris.MediaPlayer2.Player.xml
	${CMAKE_SOURCE_DIR}/src/DBus/DBusMPRIS.h
	DBusMPRIS::MediaPlayer2
	org_mpris_media_player2_player_adaptor
	OrgMprisMediaPlayer2PlayerAdaptor
)

qt5_add_dbus_interface(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.freedesktop.Notifications.xml
	Notifications
)

qt5_add_dbus_interface(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.mate.SettingsDaemon.MediaKeys.xml
	mate_settings_daemon
)

qt5_add_dbus_interface(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.gnome.SettingsDaemon.MediaKeys.xml
	gnome_settings_daemon
)

add_library(${PROJECT_NAME} STATIC ${DBUS_SOURCES} ${DBUS_HEADERS})
target_link_libraries(${PROJECT_NAME}
	sayonara_gui
	sayonara_interfaces

	Qt5::Core
	Qt5::DBus
)

install(
	FILES sayonara-query sayonara-ctl 
	DESTINATION bin
	PERMISSIONS 
		OWNER_READ OWNER_WRITE OWNER_EXECUTE 
		GROUP_READ GROUP_EXECUTE 
		WORLD_READ WORLD_EXECUTE 
)

=== src/Gui/CMakeLists.txt ===
project(sayonara_gui)

set(CMAKE_AUTOUIC ON)

file(GLOB_RECURSE GUI_SOURCES . *.cpp)
file(GLOB_RECURSE GUI_HEADERS . *.h)

set(GUI_RESOURCES
	Resources/Icons.qrc
	SomaFM/SomaFMIcons.qrc
	Soundcloud/SoundcloudIcons.qrc
)

if(WIN32)
	set(GUI_RESOURCES
		${GUI_RESOURCES}
		Resources/IconsWindows.qrc
	)
endif()

qt5_add_resources(GUI_RESOURCES_RCC
	${GUI_RESOURCES}
)

add_library(${PROJECT_NAME} STATIC ${GUI_SOURCES} ${GUI_HEADERS} ${GUI_RESOURCES_RCC})
target_link_libraries(${PROJECT_NAME}
	sayonara_components

	Qt5::Gui
	Qt5::Widgets
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/Languages/CMakeLists.txt ===
project(sayonara_languages)

file(GLOB TS_FILES . *.ts)
file(GLOB QT_QM_FILES . *.qm)

qt5_add_translation(QM_FILES ${TS_FILES})

set(QM_FILES
	${QM_FILES}
	${QT_QM_FILES}
)

if(WIN32)
	set(TRANSLATION_TARGET_PATH
		share/translations
	)
else()
	set(TRANSLATION_TARGET_PATH
		share/sayonara/translations
	)
endif()

add_custom_target(TRANSLATIONS_TARGET DEPENDS ${QM_FILES})
install(DIRECTORY ./icons DESTINATION ${TRANSLATION_TARGET_PATH} FILES_MATCHING
    PATTERN "*.png"
    PATTERN "*.svn" EXCLUDE
)

add_library(${PROJECT_NAME} STATIC ${QM_FILES})

install(FILES ${QM_FILES} DESTINATION ${TRANSLATION_TARGET_PATH})

=== src/Utils/CMakeLists.txt ===
project(sayonara_utils)

set(CMAKE_AUTOMOC OFF)

qt5_wrap_cpp(MOC_FILES
	WebAccess/AsyncWebAccess.h
	WebAccess/IcyWebAccess.h
	Language/Language.h
	Parser/StreamParser.h
	Settings/SettingNotifier.h
)

pkg_check_modules(ZLIB REQUIRED zlib)
include_directories(${ZLIB_INCLUDE_DIRS})
link_directories(${TAGLIB_LIBRARY_DIRS})

file(GLOB_RECURSE SOURCES . *.cpp)
file(GLOB_RECURSE HEADERS . *.h)

add_library(${PROJECT_NAME} STATIC ${SOURCES} ${HEADERS} ${MOC_FILES})

target_link_libraries(${PROJECT_NAME}
	Qt5::Core
	Qt5::Network
	Qt5::Xml
	Qt5::Gui
	Qt5::DBus

	${TAGLIB_LIBRARIES}
	${ZLIB_LIBRARIES}
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== debian/changelog ===
sayonara (1.6.0~beta6+ds-1) unstable; urgency=medium

  [ kokoye2007 ]
  * Initial release (Closes: #854408)

 -- Boyuan Yang <byang@debian.org>  Wed, 09 Dec 2020 22:31:42 -0500

=== debian/control ===
Source: sayonara
Section: sound
Priority: optional
Maintainer: kokoye2007 <kokoye2007@gmail.com>
Uploaders:
 Steve Meliza <swm@swm1.com>,
Rules-Requires-Root: no
Build-Depends:
 cmake (>= 3.8),
 debhelper-compat (= 13),
 dh-python,
 doxygen,
 libgstreamer-plugins-bad1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libqt5svg5-dev,
 libtag1-dev,
 libtagc0-dev,
 pkg-config,
 python3:any,
 qtbase5-dev (>= 5.6),
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
Standards-Version: 4.5.1
Homepage: http://sayonara-player.com

Package: sayonara
Architecture: any
Depends:
 gstreamer1.0-plugins-bad,
 gstreamer1.0-plugins-good,
 libqt5sql5-sqlite,
 libqt5svg5,
 python3-pydbus,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Small, clear and fast audio player
 Sayonara is a small, clear and fast audio player for Linux
 written in C++, supported by the Qt framework. One of Sayonara's
 goals is intuitive and easy usablility.

## sayonara 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,6 @@
 option(WITH_DOC "Building with doxygen support" OFF)
 option(WITH_TESTS "Building with tests" OFF)
 option(WITH_COTIRE "Building with cotire PCH and compile time optimizations" OFF)
-option(WITH_SYSTEM_TAGLIB "Use the taglib provided by the destribution, which contains critical bugs in 1.11" OFF)
 option(LINK_GSTREAMER_PLUGINS "Link the most common GStreamer plugins into the binary. Used for the creation of AppImage files")
 option(WITH_CCACHE "Use CCache if available" OFF)
 
@@ -17,7 +16,7 @@
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
 
-set(SAYONARA_VERSION "1.6.0-beta6")
+set(SAYONARA_VERSION "1.7.0-stable3")
 set(SAYONARA_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}")
 set(SAYONARA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
 set(SAYONARA_INSTALL_BIN_PATH "${CMAKE_INSTALL_PREFIX}/bin/")
@@ -52,10 +51,11 @@
 set(CMAKE_INSTALL_MANIFEST "install_manifest.txt")
 
 # doxygen
-message ("Looking for doxygen")
-find_package(Doxygen)
 
 if (WITH_DOC)
+	message ("Looking for doxygen")
+	find_package(Doxygen)
+
 	if (DOXYGEN_FOUND)
 		message ("Doxygen found")
 		set(DOXYFILE_IN "${CMAKE_SOURCE_DIR}/docs/doxygen.in")

=== resources/CMakeLists.txt ===
project(say_resources)

configure_file(version.in ${CMAKE_BINARY_DIR}/version @ONLY)

# manpage
find_program(GZIP_BINARY
	NAMES gzip	
)

if(NOT GZIP_BINARY)
    message("gzip not found. No manpage will be created")
else()
    ## create date for manpage
    execute_process(COMMAND env LC_TIME="en_US.utf8" date "+%d %B %Y" OUTPUT_VARIABLE SAYONARA_MANPAGE_DATE)
    string(REGEX REPLACE "\n$" "" SAYONARA_MANPAGE_DATE "${SAYONARA_MANPAGE_DATE}")
    
    ## create manpages
    configure_file(sayonara.1.man.in 
    	${CMAKE_CURRENT_BINARY_DIR}/sayonara.1 
    	@ONLY
    )
    configure_file(sayonara-ctl.1.man.in 
    	${CMAKE_CURRENT_BINARY_DIR}/sayonara-ctl.1 
    	@ONLY
    )
    configure_file(sayonara-query.1.man.in 
    	${CMAKE_CURRENT_BINARY_DIR}/sayonara-query.1 
    	@ONLY
    )

    ## create zipped manpage
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara.1)
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara-ctl.1)
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara-query.1)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara.1.gz" DESTINATION share/man/man1)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara-ctl.1.gz" DESTINATION share/man/man1)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara-query.1.gz" DESTINATION share/man/man1)
endif()

install(FILES "com.sayonara-player.Sayonara.desktop" DESTINATION share/applications)
install(FILES "sayonara.appdata.xml" DESTINATION share/metainfo)
install(DIRECTORY "logos/" DESTINATION share/icons/hicolor)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -36,51 +36,13 @@
 	pkg_check_modules(GIO gio-windows-2.0 REQUIRED)
 endif()
 
-
-set(TAGLIB_FOUND 0)
-
-if(WITH_SYSTEM_TAGLIB)
-	message("Looking for system taglib")
-	# overwrites TAGLIB_FOUND, TAGLIB_LIBRARY_DIRS, TAGLIB_LIBRARIES
-	pkg_check_modules(TAGLIB taglib>=1.10 REQUIRED)
-
-	# Some distributions do not clean the taglib include path
-	# or the pkg-config .pc file for taglib after uninstalling
-	find_path(TAGLIB_INCLUDE_FOUND "audioproperties.h" PATHS ${TAGLIB_INCLUDE_DIRS})
-	if(NOT TAGLIB_INCLUDE_FOUND)
-		message(FATAL_ERROR "Taglib does not seem to be fully installed" )
-	endif()
-endif()
-
-if(NOT TAGLIB_FOUND)
-	set(WITH_SYSTEM_TAGLIB 0)
-
-	set(TAGLIB_INCLUDE_DIRS
-		${CMAKE_SOURCE_DIR}/src/3rdParty
-		${CMAKE_CURRENT_BINARY_DIR}/3rdParty
-		${CMAKE_CURRENT_BINARY_DIR}/3rdParty/taglib
-	)
-
-	set(TAGLIB_LIBARARY_DIRS
-		${CMAKE_CURRENT_BINARY_DIR}/3rdParty/taglib
-	)
-
-	set(TAGLIB_LIBRARY_DIRS ${CMAKE_CURRENT_BINARY_DIR}/3rdParty/taglib/taglib)
-	set(TAGLIB_LIBRARIES tag)
-	
-	# Macros.h.in
-	set(SAYONARA_INTERNAL_TAGLIB 1)
-else()
-	# Macros.h.in
-	set(SAYONARA_SYSTEM_TAGLIB 1)
-endif()
-
 pkg_check_modules(GLIB glib-2.0 REQUIRED)
 pkg_check_modules(GOBJECT gobject-2.0 REQUIRED)
 pkg_check_modules(GSTREAMER gstreamer-1.0 REQUIRED)
 pkg_check_modules(GSTREAMER_BASE gstreamer-base-1.0 REQUIRED)
 pkg_check_modules(GSTREAMER_BASE_APP gstreamer-app-1.0 REQUIRED)
 pkg_check_modules(ZLIB REQUIRED zlib REQUIRED)
+pkg_check_modules(TAGLIB REQUIRED taglib REQUIRED)
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
@@ -129,17 +91,24 @@
 	set(WIN32 0)
 endif()
 
-# check execinfo for FreeBSD
+# check libexecinfo for non-glibc systems
 if(WIN32)
 	link_directories(${GIO_LIBRARY_DIRS})
-elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
-	find_library(execinfo_LIB execinfo)
-	if(NOT execinfo_LIB)
-		message(FATAL_ERROR "FreeBSD requires execinfo library")
+else()
+	include(CheckSymbolExists)
+	message("Checking if backtrace symbol present")
+	check_symbol_exists(backtrace execinfo.h backtrace_exists)
+	if(NOT backtrace_exists)
+		message("backtrace is missing (non-glibc platform), trying to find libexecinfo")
+		find_library(execinfo_LIB execinfo)
+		if(NOT execinfo_LIB)
+			message(FATAL_ERROR "libexecinfo not found")
+		endif()
+		set(OS_LIBRARIES ${execinfo_LIB})
+	else()
+		set(SAYONARA_HAS_BACKTRACE 1)
 	endif()
-	set(OS_LIBRARIES ${execinfo_LIB})
 endif()
-
 
 # Check demangle
 check_include_file_cxx("cxxabi.h" HAVE_CXX_ABI)
@@ -157,7 +126,6 @@
 set(CMAKE_AUTOUIC OFF)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
-add_subdirectory(3rdParty)
 add_subdirectory(Application)
 add_subdirectory(Components)
 add_subdirectory(Database)
@@ -189,8 +157,8 @@
 	${OS_LIBRARIES}
 )
 
-add_executable("create_db" CreateDB.cpp ${DATABASE_RCC})
-target_link_libraries("create_db"
+add_executable("create-database" CreateDB.cpp ${DATABASE_RCC})
+target_link_libraries("create-database"
 	sayonara_utils
 	sayonara_database
 	Qt5::Widgets

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-project(say_tests)
+project(sayonara-test)
 include("NewTest.cmake")
 include(${CMAKE_SOURCE_DIR}/src/CMake/Compiler.cmake)
 
@@ -45,34 +45,51 @@
 	${RESOURCES}
 )
 
-# With resources
+new_test(AudioConverter/AudioConverterTest.cpp)
+
 new_test(Covers/CoverLocationTest.cpp)
+new_test(Covers/CoverFetchManagerTest.cpp)
 
 new_test(Database/PodcastTest.cpp)
 new_test(Database/AlbumTest.cpp)
 new_test(Database/LibraryDatabaseTest.cpp)
+new_test(DynamicPlayback/ArtistMatchTest.cpp)
+
+new_test(Equalizer/EqualizerTest.cpp)
 
 new_test(Library/ImportCacheTest.cpp)
+new_test(Library/LibraryManagerTest.cpp)
 
 new_test(Playlist/PlaylistTest.cpp Playlist/PlaylistTestUtils.cpp)
 new_test(Playlist/PlaylistTrackModifyTest.cpp Playlist/PlaylistTestUtils.cpp)
+new_test(Playlist/PlaylistFileTest.cpp)
+new_test(Playlist/PlaylistHandlerTest.cpp)
 
 new_test(StreamRecorder/StreamRecorderTest.cpp)
 new_test(StreamRecorder/StreamRecorderUtilsTest.cpp)
 
 new_test(Tagging/AlbumArtistTest.cpp Tagging/AbstractTaggingTest.cpp)
+new_test(Tagging/CoverTest.cpp  Tagging/AbstractTaggingTest.cpp)
 new_test(Tagging/DiscnumberTest.cpp Tagging/AbstractTaggingTest.cpp)
 new_test(Tagging/EditorTest.cpp)
 new_test(Tagging/LyricsTest.cpp Tagging/AbstractTaggingTest.cpp)
 new_test(Tagging/RatingTest.cpp Tagging/AbstractTaggingTest.cpp)
 new_test(Tagging/TagFromPathTest.cpp)
+new_test(Tagging/TaggingTest.cpp Tagging/AbstractTaggingTest.cpp)
 
+new_test(Util/UtilTest.cpp)
+new_test(Util/AsyncWebAccessTest.cpp)
 new_test(Util/CryptTest.cpp)
 new_test(Util/FileHelperTest.cpp)
 new_test(Util/LanguageKeyTest.cpp)
 new_test(Util/LanguageUtilTest.cpp)
+new_test(Util/LibraryFilterTest.cpp)
 new_test(Util/MetaDataTest.cpp)
 new_test(Util/MetaDataListTest.cpp)
+new_test(Util/MimeDataTest.cpp  ${CMAKE_SOURCE_DIR}/src/Gui/Utils/MimeData/CustomMimeData.cpp)
+new_test(Util/PlaylistModeTest.cpp)
 new_test(Util/SettingsTest.cpp)
 new_test(Util/SetTest.cpp)
 new_test(Util/CissearchTest.cpp)
+new_test(Util/StandardPathTest.cpp)
+new_test(Util/TreeTest.cpp)

=== src/Languages/CMakeLists.txt ===
project(sayonara_languages)

file(GLOB TS_FILES . *.ts)

if(WIN32)
	set(TRANSLATION_TARGET_PATH
		share/translations
	)
else()
	set(TRANSLATION_TARGET_PATH
		share/sayonara/translations
	)
endif()

qt5_add_translation(QM_FILES ${TS_FILES})
install(DIRECTORY ./icons
	DESTINATION ${TRANSLATION_TARGET_PATH}
	FILES_MATCHING PATTERN "*.png"
)

add_library(${PROJECT_NAME} STATIC ${QM_FILES})

install(FILES ${QM_FILES} DESTINATION ${TRANSLATION_TARGET_PATH})

## sayonara 1.7.0+git20210515

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
 
-set(SAYONARA_VERSION "1.7.0-stable3")
+set(SAYONARA_VERSION "1.7.0-stable1")
 set(SAYONARA_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}")
 set(SAYONARA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
 set(SAYONARA_INSTALL_BIN_PATH "${CMAKE_INSTALL_PREFIX}/bin/")

## sayonara 1.7.0-stable3

=== debian/changelog ===
sayonara (1.7.0-stable3-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/0001-Reproducible-build.patch: Apply patch to
    make the package reproducible. (Closes: #977486).

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Aug 2021 17:53:01 -0400

sayonara (1.7.0-stable3-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version.
  * debian/patches: Drop all patches, merged upstream.

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Aug 2021 14:53:18 -0400

sayonara (1.6.0~beta6+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload. 
  * Source-only upload.
  * debian/control: Add Vcs-* fields.

 -- Boyuan Yang <byang@debian.org>  Thu, 17 Dec 2020 14:26:29 -0500

=== debian/control ===
--- 
+++ 
@@ -24,6 +24,8 @@
  zlib1g-dev,
 Standards-Version: 4.5.1
 Homepage: http://sayonara-player.com
+Vcs-Git: https://salsa.debian.org/debian/sayonara.git
+Vcs-Browser: https://salsa.debian.org/debian/sayonara
 
 Package: sayonara
 Architecture: any

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/sayonara-player.*\.tar\.gz/sayonara-player-$1\.tar\.gz/g \
  https://gitlab.com/luciocarreras/sayonara-player/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*
